# Low Latency Tuning Guide

In this document, we listed all the tuning techniques that we plan to implement and test on AWS instances to see there improvement on latency.
And we divide all the tuning techniques into two documents: one is [OS level tuning techniques](./OS_TUNING.md), and anther is [hardware level tuning techniques](./HARDWARE_TUNING.md). You can also directly go to the description of a specific tuning technique by clicking on the links below.

> NOTE: Since kernal bypass is closely related to the NIC of the server that we are using and varied hardware features(e.g. Onload feature for Solarflare NIC), we placed kernal bypass into the hardware tuning techniques document.

## Table of Contents

- [Tuning Techniques](#tuning-techniques)
  - [Table of Contents](#table-of-contents)
  - [TCP Tuning](./OS_TUNING.md#tcp-tuning)
    - [Diable Nagle](#diable-nagle)
    - [Receive and Send buffers](#receive-and-send-buffers)
    - [Quick Acknowledgement](#quick-acknowledgement)
    - [Fast Open(Handshake faster)](#fast-openhandshake-faster)
    - [Keep Alive](#keep-alive)
  - [Isolating CPU Core](./OS_TUNING.md#isolating-cpu-core)
    - [Steps to Isolate a CPU](#steps-to-isolate-a-cpu)
    - [Assigning a Process to an Isolated Core](#assigning-a-process-to-an-isolated-core)
  - [IRQ Processing](./OS_TUNING.md#irq-processing)
    - [How IRQ Works](#how-irq-works)
    - [Commands that manage IRQ on Linux](#commands-that-manage-irq-on-linux)
    - [Configuring IRQ Affinity](#configuring-irq-affinity)
  - [Busy Polling](./OS_TUNING.md#busy-polling)
    - [How it helps with low latency tuning](#how-it-helps-with-low-latency-tuning)
    - [Considerations when using Busy Polling](#considerations-when-using-busy-polling)
  - [NIC/Ethernet Adaptor Tuning](./HARDWARE_TUNING.md#nicethernet-adaptor-tuning)
    - [Diable IRQ Coalescing](#diable-irq-coalescing)
    - [Checksum Offloading](#checksum-offloading)
    - [Other features Offload](#other-features-offload)
    - [Adjust Ring Buffer Size](#adjust-ring-buffer-size)
    - [Quality of Service(QoS)](#quality-of-serviceqos)
    - [Flow Control](#flow-control)
    - [Receive-Side Scaling (RSS)](#receive-side-scaling-rss)
  - [CPU Power Saving Mode(To check if applicable to AWS)](./OS_TUNING.md#cpu-power-saving-modeto-check-if-applicable-to-aws)
  - [BIOS/UEFI Settings](./HARDWARE_TUNING.md#biosuefi-settings)
    - [Diable C-States and P-States](#diable-c-states-and-p-states)
    - [Enable High Precision Event Timer (HPET)](#enable-high-precision-event-timer-hpet)
  - [Kernal Bypass](./HARDWARE_TUNING.md#kernal-bypass)
    - [Solarflare OpenOnload](#solarflare-openonload)
    - [DPDK (Data Plane Development Kit)](#dpdk-data-plane-development-kit)
    - [RDMA (Remote Direct Memory Access)](#rdma-remote-direct-memory-access)
    - [AF_XDP(Linux Native)](#af_xdplinux-native)
    - [Differences between using DPDK and AF_XDP](#differences-between-using-dpdk-and-af_xdp)
  - [Memory Settings](./OS_TUNING.md#memory-settings)
    - [Disable Transparent Huge Pages (THP)](#disable-transparent-huge-pages-thp)
    - [Tuning Memory Swappiness](#tuning-memory-swappiness)
  - [PCIe Settings](./HARDWARE_TUNING.md#pcie-settings)
    - [PCIe Active State Power Management (ASPM)](#pcie-active-state-power-management-aspm)
    - [MSI (Message Signaled Interrupts)](#msi-message-signaled-interrupts)
  - [I/O Scheduler in Storage Devices](./HARDWARE_TUNING.md#io-scheduler-in-storage-devices)
  - [Python Tuning](./OS_TUNING.md#python-tuning)
    - [Switch to Pypy](#switch-to-pypy)
    - [Use C-Optimized SSL Library](#use-c-optimized-ssl-library)
    - [Configuring Specific SSL Ciphers](#configuring-specific-ssl-ciphers)
    - [Memory Management](#memory-management)
